//============================================================================
//	aisa31bw.pas
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 Date 1999/10/14
//
//============================================================================

unit aisa31bw;

interface

uses
	Windows;

//-------------------------------------
// װޒ萔
//-------------------------------------
const
	AISA31B_SUCCESS		     = 0;	// I
	AISA31B_ERR_SYSTEM	     = 1;	// GetLastError sĂ
	AISA31B_ERR_NO_DEVICE	     = 2;	// gp\޲Ȃ
	AISA31B_ERR_IN_USE	     = 3;	// w肳ꂽ޲͎gp
	AISA31B_ERR_INVALID_SLOT     = 4;       // Ș_ۯĔԍw肵
	AISA31B_ERR_RESOURCE	     = 5;	// ؿװ
	AISA31B_ERR_INVALID_PORT     = 6;	// ߰Ăv
	AISA31B_ERR_INVALID_ARGUMENT = 7;	// Ȉv
	AISA31B_ERR_NO_CREATE	     = 8;	// ޲شĂĂ܂
	AISA31B_ERR_WRAPDLL	     =Dword(-1);// ׯ߰֐װ
//-------------------------------------
// ߰Ĕԍ萔
//-------------------------------------
	AISA31B_PORT_1 = 0;
	AISA31B_PORT_2 = 1;
	AISA31B_PORT_3 = 2;
	AISA31B_PORT_4 = 3;
//-------------------------------------
// ̑萔
//-------------------------------------
	AISA31B_DLL_NAME  = 'aisa31b.dll';	// DLĻٖ
	AISA31B_MAX_PORTS = 4;			// ߰Đ
	AISA31B_MAX_SLOTS = 16;			// őۯĐ
	AISA31B_DEVICE_ID = $136c9031;	        // ޲ID
	AISA31B_SLOT_AUTO = $ffff;	        // AutoSlotl
//-------------------------------------
// ؿ\
//-------------------------------------
	AISA31B_MAX_MEM	= 9;
	AISA31B_MAX_IO	= 20;
	AISA31B_MAX_IRQ	= 7;
	AISA31B_MAX_DMA	= 7;

type
	TAISA31BRESOURCE = record
		dwNumMemWindows:																DWORD;	// س޳(gp)
		dwMemBase:	array [1 .. AISA31B_MAX_MEM] of	DWORD;	// س޳ްڽ(gp)
		dwMemLength:	array [1 .. AISA31B_MAX_MEM] of	DWORD;	// س޳(gp)
		dwMemAttrib:	array [1 .. AISA31B_MAX_MEM] of	DWORD;	// س޳(gp)
		dwNumIOPorts:	                                DWORD;	// I/O߰Đ
		dwIOPortBase:	array [1 .. AISA31B_MAX_IO] of	DWORD;	// I/O߰ްڽ
		dwIOPortLength: array [1 .. AISA31B_MAX_IO] of	DWORD;	// I/O߰Ē
		dwNumIRQs:	                                DWORD;	// IRQ(gp)
		dwIRQRegisters: array [1 .. AISA31B_MAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwIRQAttrib:	array [1 .. AISA31B_MAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwNumDMAs:					DWORD;	// DMAِ(gp)
		dwDMALst:	array [1 .. AISA31B_MAX_DMA] of	DWORD;	// DMAؽ(gp)
		dwDMAAttrib:	array [1 .. AISA31B_MAX_DMA] of	DWORD;	// DMAّؽ(gp)
		dwReserved1:	array [1 .. 3] of		DWORD;	// \(gp)
	end;
//-------------------------------------
// J֐
//-------------------------------------
// DLL ۰
function Aisa31bwDllOpen: Boolean;
// DLL ۰
function Aisa31bwDllClose: Boolean;
// aISA-P31B DLL,޲ײްްޮݔԍ擾
function Aisa31bwGetVersion(var pdwDllVersion:DWord; var pdwDriverVersion:DWord): Boolean;
// CӂaISA-P31B̎gp錾
function Aisa31bwCreate(var pwLogSlot:Word): Boolean;
// CӂaISA-P31B̎gpJ
function Aisa31bwClose(wLogSlot:Word): Boolean;
// ؿ擾
function Aisa31bwGetResource(wLogSlot:Word; var pResInfo:TAISA31BRESOURCE): Boolean;
// Cӂ߰Ăް
function Aisa31bwInPort(wLogSlot:Word; dwLogPort:DWord; var pbInValue:Byte): Boolean;
// Cӂ߰Ăްo
function Aisa31bwOutPort(wLogSlot:Word; dwLogPort:DWord; bOutValue:Byte): Boolean;
// aISA-P31B̴װ
function Aisa31bwGetLastError(wLogSlot:Word): DWord;

//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
implementation

{$J+}	// ^t萔̕ύX\߲׎w
const
	hDLL: THandle = 0;

type
	TAisa31bGetVersion = function(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): BOOL; stdcall;
	TAisa31bCreate = function(var pwLogSlot:Word): BOOL; stdcall;
	TAisa31bClose = function(wLogSlot:WORD): BOOL; stdcall;
	TAisa31bGetResource = function(wLogSlot:WORD; var pres:TAISA31BRESOURCE): BOOL; stdcall;
	TAisa31bInPort = function(wLogSlot:WORD; dwLogPort:DWORD; var pbInValue:BYTE): BOOL; stdcall;
	TAisa31bOutPort = function(wLogSlot:WORD; dwLogPort:DWORD; bOutValue:BYTE): BOOL; stdcall;
	TAisa31bGetLastError = function(wLogSlot:WORD): DWORD; stdcall;

// DLL ߰Ċ֐ڽ̊i[ϐ
var
	pAisa31bGetVersion: TAisa31bGetVersion;
	pAisa31bCreate: TAisa31bCreate;
	pAisa31bClose: TAisa31bClose;
	pAisa31bGetResource: TAisa31bGetResource;
	pAisa31bInPort: TAisa31bInPort;
	pAisa31bOutPort: TAisa31bOutPort;
	pAisa31bGetLastError: TAisa31bGetLastError;

function Aisa31bwGetDllExportFunc: Boolean; forward;

{$J-}

//============================================================================
// 		aisa31b.dll۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Aisa31bwDllOpen: Boolean;
begin
	Result := False;
	if hDLL = 0 then begin
		hDLL := LoadLibrary(AISA31B_DLL_NAME);
		if hDLL <> 0 then begin
			Result := Aisa31bwGetDllExportFunc;
			if Result <> True then
				Aisa31bwDllClose;			// DLL֐擾ɎŝDLL۰
		end;
	end;
end;
//============================================================================
// 	  aisa31b.dll۰(۰ގʹװƂ)
// 	  
// ߂l  True
//	  s False
//============================================================================
function Aisa31bwDllClose: Boolean;
begin
	Result := False;
	if hDLL <> 0 then begin
		Result := FreeLibrary(hDLL);
		if Result = True then begin
			hDLL := 0;
		end;
	end;
end;
//============================================================================
// 	  aISA-P31B DLL,޲ײްްޮݔԍ擾
// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
//	  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  True
//	  s False
//============================================================================
function Aisa31bwGetVersion(var pdwDllVersion:DWord; var pdwDriverVersion:DWord): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pAisa31bGetVersion(pdwDllVersion, pdwDriverVersion)
end;
//============================================================================
// 	  aISA-P31B̔Cӂ޲̎gp錾
// 	  pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l  True
//	  s False
//============================================================================
function Aisa31bwCreate(var pwLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pAisa31bCreate(pwLogSlot)
end;
//============================================================================
// 	  aISA-P31B̔Cӂ޲̎gpJ
// 	  wLogSlot       ޲̘_ۯĔԍ
// ߂l  True
//	  s False
//============================================================================
function Aisa31bwClose(wLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pAisa31bClose(wLogSlot)
end;
//============================================================================
// 	  w޲ؿ擾
// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
//	  pResInfo	ؿi[\߲̂
// ߂l  True
//	  s False
//============================================================================
function Aisa31bwGetResource(wLogSlot:Word; var pResInfo:TAISA31BRESOURCE): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pAisa31bGetResource(wLogSlot, pResInfo)
end;
//============================================================================
// 	  Cӂ߰Ăް
// 	  wLogSlot	͂޲̘_ۯĔԍ
//	  dwLogPort	͂_߰
//	  pbInValue     ްi[̈ւ߲
// ߂l  True
//	  s False
//============================================================================
function Aisa31bwInPort(wLogSlot:Word; dwLogPort:DWord; var pbInValue:Byte): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pAisa31bInPort(wLogSlot, dwLogPort, pbInValue)
end;
//============================================================================
// 	  Cӂ߰Ăްo
// 	  wLogSlot	o͂޲̘_ۯĔԍ
//	  dwLogPort	o͂_߰
//	  bOutValue     o͂ް
// ߂l  True
//	  s False
//============================================================================
function Aisa31bwOutPort(wLogSlot:Word; dwLogPort:DWord; bOutValue:Byte): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pAisa31bOutPort(wLogSlot, dwLogPort, bOutValue)
end;
//============================================================================
// 	  aISA-P31B̴װ
// 	  wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//============================================================================
function Aisa31bwGetLastError(wLogSlot:Word): DWord;
begin
	if hDLL = 0 then Result := AISA31B_ERR_WRAPDLL
	else Result := pAisa31bGetLastError(wLogSlot)
end;
//---------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  True
//	  s False
//---------------------------------------------------------------------------
function Aisa31bwGetDllExportFunc: Boolean;
begin
	Result := False;
	// Aisa31bGetVersion ̱ڽ擾
	pAisa31bGetVersion := GetProcAddress(hDLL, 'Aisa31bGetVersion');
	if @pAisa31bGetVersion = nil then Exit;
	// Aisa31bCreate ̱ڽ擾
	pAisa31bCreate := GetProcAddress(hDLL, 'Aisa31bCreate');
	if @pAisa31bCreate = nil then Exit;
	// Aisa31bClose ̱ڽ擾
	pAisa31bClose := GetProcAddress(hDLL, 'Aisa31bClose');
	if @pAisa31bClose = nil then Exit;
	// Aisa31bGetResource ̱ڽ擾
	pAisa31bGetResource := GetProcAddress(hDLL, 'Aisa31bGetResource');
	if @pAisa31bGetResource = nil then Exit;
	// Aisa31bInPort ̱ڽ擾
	pAisa31bInPort := GetProcAddress(hDLL, 'Aisa31bInPort');
	if @pAisa31bInPort = nil then Exit;
	// Aisa31bOutPort ̱ڽ擾
	pAisa31bOutPort := GetProcAddress(hDLL, 'Aisa31bOutPort');
	if @pAisa31bOutPort = nil then Exit;
	// Aisa31bGetLastError ̱ڽ擾
	pAisa31bGetLastError := GetProcAddress(hDLL, 'Aisa31bGetLastError');
	if @pAisa31bGetLastError = nil then Exit;
	// SĂ DLL ߰Ċ֐ڽ擾nj
	Result := True;
end;

end.

